setInfos(9, "BuzzQuiz competition", 
	"Video forfeits competition basic structure for BuzzQuiz: wager a forfeit against your score.",
	"NIFOC99", "v0.4", 0xffffff, "en", ["formale", "forfemale", "game", "exhibition", 
	"internet", "dare"])
// v0.1 beta first release
// v0.2 beta typos corrected, changes to min and max scores
// v0.3 beta minimum score must be >0.0 for forfiets, check for null forfeit
// v0.4 integration with BuzzQuiz

def BQVersion = "v0.4"
setImage(null) //start tidily
show(null)
def Title = "<h1 style='font-size:140%;'>BuzzQuiz Competition</h1>\n"
//check version
if(receiveString("BQ.Version")!=BQVersion){
	show(Title+"This ("+BQVersion+") is not the latest version ("+receiveString("BQ.Version")+").")
	wait(1)
	showButton("OK")
}
show(Title+"("+BQVersion+")\n\nWelcome to the BuzzQuiz forfeits competition."+
	"\n\nPlayers have to set their own individual forfeits that they are "+
	"willing to post as videos (or photos) on the internet (e.g. PornHub, "+
	"etc.). Forfeits are graded and depend on how badly each player scores. "+
	"Only the winner doesn't have to post a video.\n\nOnce a competition "+
	"date is set, players have seven days to play BuzzQuiz and join the "+
	"competition. They can play BuzzQuiz as often as they like, and "+
	"register their best score.\n\nThe players then have four more days "+
	"to video and upload their forfeits and register the URL in this script. "+
	"The links stay in this script for at least the next three days or until "+
	"recruitment for a new competition is started.\n\nAny player may start a "+
	"competition.")
showButton("OK")
show(Title+"loading data...")

//info about current player
def BQMyID = loadInteger("intro.launch.firsttime")
def BQMyName = loadString("intro.name").replaceAll("\\|", "/")
def BQMyForfeit
def BQMyResult
def BQMyURL

float BQPoints1, BQPoints2
def BQPlayers = receiveInteger("BQ.Enrolled")?: 0 //number of players
def BQIDs = [] //list of IDs
def BQCodes0 = [] //list of coded data from server
def BQCodes1 = [] //list of coded data with possible changes
//[0:name, 1:forfeit1, 2:forfeit2, 3:forfeit3, 4:forfeit4, 5:score (as text), 6:result (as text), 7:URL]
// result:
//	-1:	before the competition
//	0:	winner - best score (no forfeit)
//	1:	top third of scores (forfeit 1)
//	2:	middle third of scores (forfeit 2)
//	3:	bottom third of scores (forfeit 3)
//	4:	loser - worst score greater than zero (forfeit 4)
//	5:	didn't play - zero score (no forfeit)
//generate dates
Date BQNow = new Date()
//start time of playing
def BQDate0String = receiveString("BQ.StartTime")?: "Thu Apr 18 06:00:00 BST 2019"
Date BQDate0 = Date.parse("E MMM dd H:m:s z yyyy", BQDate0String) //end of play
Date BQDate1 = BQDate0.plus(4) //end of forfeits
Date BQDate2 = BQDate1.plus(3) //eariest time for next tournament

//Closures (functions)#############################################################################

def getAllIDs = {//-------------------------------------------------------------------------------
	for(def i=0; i<BQPlayers; i++){BQIDs << receiveInteger("BQ.ID"+i)}
}

def getAllCodes = {//-----------------------------------------------------------------------------
	for(def i=0; i<BQPlayers; i++){
		def BQ1 = receiveString("BQ."+BQIDs[i])
		BQCodes0 << BQ1
		BQCodes1 << BQ1
	}
}

def getCode = {def C, j -> //----------------------------------------------------------------------
	def S1 = 0; def S2 = 0
	if(C==null||C.count("|")!=8||j>7){
		show(Title+"Error in code")
		showButton("OK")
		return "0"
	}
	for(def i=0; i<C.count("|"); i++){
		S2 = C.indexOf("|", S1)
		if(i==j){return C.substring(S1, S2)}
		S1 = S2+1
	}
}

def makeCode = {def C, j, x ->//-------------------------------------------------------------------
	def S1 = 0; def S2 = 0; def t=""
	if(C==null||C.count("|")!=8||j>7){
		show(Title+"Error in code")
		showButton("OK")
		return "0"
	}
	for(def i=0; i<C.count("|"); i++){
		S2 = C.indexOf("|", S1)
		if(i!=j){t = t+C.substring(S1, S2)+"|"}
		else{t = t+x+"|"}
		S1 = S2+1
	}
	return t
}

def BQGetForfeits = {def j -> //forfeits-----------------------------------------------------------
//define proposed forfeits
	def BQForfeits1 = [ "video: strip",
		"video: strip; get hard; balance coin on dick for 60s",
		"photo: naked, full body" ]
	def BQForfeits2 = [ "video: strip; spank 20 times",
		"video: strip; insert butt plug or nipple clamps",
		"video/photo: strip; cum shot" ]
	def BQForfeits3 = [ "video: strip; ball-busting (fruit in a sock) 20 times",
		"video: strip; 20 strokes of the cane",
		"video/photo: strip; write DARE JUNKIE on chest" ]
	def BQForfeits4 = [ "video: strip; fill a glass with piss or cum; drink",
		"video: strip; cane balls until bright red",
		"photo: naked in public" ]
	def BQForfeit
//input forfeits and save
//forfeit 1
	BQForfeit = getSelectedValue(Title+"Forfeit 1\n\nThis should be a basic forfeit for scoring well, "+
			"but not good enough to wim. Chose "+
			"one of the suggestions; you can edit it (e.g. more slaps, etc.) on the next "+
			"screen.\n\nVideos and pictures of any forfeits must be posted to PornHub (or a "+
			"similar site) and the URLs shared here.", BQForfeits1)
	BQMyForfeit = getString(Title+"You can now edit your forfeit. You can change it completely if "+
			"you want.", BQForfeits1[BQForfeit])
	if(BQMyForfeit.length()<5){return false}
	BQCodes1[j] = makeCode(BQCodes1[j], 1, BQMyForfeit.replaceAll("\\|", "/"))
//forfeit 2
	BQForfeit = getSelectedValue(Title+"Forfeit 2\n\nThis should be a more unpeasant or "+
			"ebmarrasing forfeit for a mediocre result. Chose one of the suggestions; you can edit it on the next "+
			"screen.\n\nVideos and pictures of any forfeits must be posted to PornHub (or a "+
			"similar site) and the URLs shared here.", BQForfeits2)
	BQMyForfeit = getString(Title+"You can now edit your forfeit. You can change it completely if "+
			"you want.", BQForfeits2[BQForfeit])
	if(BQMyForfeit.length()<5){return false}
	BQCodes1[j] = makeCode(BQCodes1[j], 2, BQMyForfeit.replaceAll("\\|", "/"))
//forfeit 3
	BQForfeit = getSelectedValue(Title+"Round 3 forfeit\n\nThis should be a painful or "+
			"humiliating forfeit for scoring badly, baut not coming last. Chose one of the suggestions; "+
			"you can edit it on the next "+
			"screen.\n\nVideos and pictures of any forfeits must be posted to PornHub (or a "+
			"similar site) and the URLs shared here.", BQForfeits3)
	BQMyForfeit = getString(Title+"You can now edit your forfeit. You can change it completely if "+
			"you want.", BQForfeits3[BQForfeit])
	if(BQMyForfeit.length()<5){return false}
	BQCodes1[j] = makeCode(BQCodes1[j], 3, BQMyForfeit.replaceAll("\\|", "/"))
//forfeit 4
	BQForfeit = getSelectedValue(Title+"Round 4 forfeit\n\nThis should be your worst-fear forfeit for coming last. "+
			"Chose one of the suggestions; you can edit it on the next screen. Be specific, "+
			"we want to know the worst <em>you</em> are prepared to do (even if you don't get "+
			"to do it). Don't say you'll do something someone else asks on skype, as this doesn't "+
			"tell us about <em>you.</em>\n\nVideos and "+
			"pictures of any forfeits must be posted to PornHub, XTube (or a similar site) and the "+
			"URLs shared here.", BQForfeits4)
	BQMyForfeit = getString(Title+"You can now edit your forfeit. You can change it completely if "+
			"you want.", BQForfeits4[BQForfeit])
	if(BQMyForfeit.length()<5){return false}
	BQCodes1[j] = makeCode(BQCodes1[j], 4, BQMyForfeit.replaceAll("\\|", "/"))
	return true
}

def getURL = {def j -> //get and test URL----------------------------------------------------------
	def BQtest = true
	while(BQtest){
		BQMyURL = getString("URL of forfeit", "")
		if(BQMyURL.indexOf("http://")==0||BQMyURL.indexOf("https://")==0){
			if(getBoolean(Title+"Do you want to test the URL?")){
				useUrl(BQMyURL)
				if(getBoolean(Title+"Is the URL OK?")){BQtest = false}
			}
			else {BQtest = false}
		}
		else {
			show(Title+"URL must start http:// or https://")
			showButton("OK")
		}
	}
	if(!BQtest){BQCodes1[j] = makeCode(BQCodes1[j], 7, BQMyURL)}
}

def BQShowForfeits = {//and scores-----------------------------------------------------------------
	def BQ1 //ID
	def BQOutputString
	def BQChoices
	if(BQPlayers<1){
		show(Title+"Nothing to show!")
		showButton("OK")
		return
	}
	for(def i=0; i<BQPlayers; i++){//loop over players
		BQChoices = ["Next", "Quit"]
		show(Title+"accessing...");
		BQOutputString = Title+"<h1>"+getCode(BQCodes1[i], 0)+"</h1>"+
			"Points "+getCode(BQCodes1[i], 5)
		BQMyResult = getCode(BQCodes1[i], 6).toInteger()
		if(BQMyResult<0){
			BQOutputString = BQOutputString+"\n\nForfeits<ol>"
			for(def j=1; j<=4; j++){//loop over forfeits
				BQOutputString = BQOutputString+"<li>Forfeit "+j+" "+
					getCode(BQCodes1[i], j)+"</li>"
			}
			BQOutputString = BQOutputString+"</ol>"
		}
		else if(BQMyResult==0){
				BQOutputString = BQOutputString+"\n\nWinner - no forfeit this time"
		}
		else if(BQMyResult<5){
			BQMyURL = getCode(BQCodes1[i], 7)
			BQOutputString = BQOutputString+"\n\nForfeit\n"+getCode(BQCodes1[i], BQMyResult)+
				"\n\nURL "+BQMyURL
			BQChoices << "open URL"
		}
		else{
			BQOutputString = BQOutputString+"\n\nNo forfeit - didn't play"
		}
		switch(getSelectedValue(BQOutputString, BQChoices)){
		case 1: 
			i = BQPlayers
			break
		case 2: 
			if(BQMyURL.indexOf("http://")==0||BQMyURL.indexOf("https://")==0){
				useUrl(BQMyURL)
			}
			else {
				show(Title+"Invalid URL")
				showButton("OK")
			}
			break
		}
	}
}

def BQStart = {Date BQDate -> //Generate new start date--------------------------------------------
	if(getBoolean(Title+"Do you want to start a new tournament?")){
		def BQy = getInteger("Start date: Year", BQDate.year+1900)
		def BQm = getInteger("Start date: Month", BQDate.month+1)
		def BQd = getInteger("Start date: Day", BQDate.date)
		BQDate = new Date(BQy-1900, BQm-1, BQd, 6, 0, 0)
		if(BQNow.before(BQDate.minus(7))&&BQNow.after(BQDate.minus(14))){
			if(getBoolean(Title+"Start date: "+BQDate)){
				send("BQ.StartTime", BQDate)
				send("BQ.Enrolled", 0)
			}
		}
		else {
			show(Title+"Start date must be within 7 days")
			showButton("OK")
		}
	}
}

def BQEnrolled = {//------------------------------------------------------------------------------
	if(BQPlayers>0){//don't try to access players not there
		for(def i=0; i<BQPlayers; i++){//loop over players
			if(BQMyID==BQIDs[i]){return i}
		}
	}
	return -1
}

def BQCalcForfeits = {//--------------------------------------------------------------------------
	show(Title+"compiling results...")
	float BQscore0 = 1000000.0 //min
	float BQscore1 = 0.0 //max
	for(def i=0; i<BQPlayers; i++){
		float BQ1 = Float.parseFloat(getCode(BQCodes1[i], 5))
		if(BQ1<BQscore0&&BQ1>0.0){BQscore0 = BQ1}
		if(BQ1>BQscore1){BQscore1 = BQ1}
	}
	float BQscore2 = (2.0*BQscore0+BQscore1)/3.0 //bottom third
	float BQscore3 = (BQscore0+2.0*BQscore1)/3.0 //top third
	for(def i=0; i<BQPlayers; i++){
		float BQ1 = Float.parseFloat(getCode(BQCodes1[i], 5))
		if(BQ1==0.0){BQCodes1[i] = makeCode(BQCodes1[i], 6, "5")} //non-player
		else if(BQ1==BQscore0){BQCodes1[i] = makeCode(BQCodes1[i], 6, "4")} //loser
		else if(BQ1<=BQscore2){BQCodes1[i] = makeCode(BQCodes1[i], 6, "3")} // < one third
		else if(BQ1<=BQscore3){BQCodes1[i] = makeCode(BQCodes1[i], 6, "2")} // < two thirds
		else if(BQ1==BQscore1){BQCodes1[i] = makeCode(BQCodes1[i], 6, "0")} //winner
		else {BQCodes1[i] = makeCode(BQCodes1[i], 6, "1")} // > two thirds
	}
}

//-------------------------------------------------------------------------------------------------

//Start ###########################################################################################
getAllIDs()
getAllCodes()
//play --------------------------------------------------------------------------------------------
if(BQNow.before(BQDate0)){
	show(Title+"The tournament is in play recruiting players for up to "+
			BQDate0.format("dd-MMM-yyyy HH:mm:ss"))
	showButton("OK")
	def BQ1 = BQEnrolled()
	if(BQ1<0){//not enrolled
		if(getBoolean(Title+"Do you want to play in the next tournament?\n\n"+
			"You will have to provide four forfeits that you are prepared to "+
			"perform if you lose.\n\nDon't promise to do something you're not prepared to do!\n\n"+
			"Only the winner doesn't have to do a forfeit.")){
			BQCodes1 << BQMyName+"|"+
				"Forfeit1|"+
				"Forfeit2|"+
				"Forfeit3|"+
				"Forfeit4|"+
				"0.0|"+
				"-1|"+
				"no link|"
			if(BQGetForfeits(BQPlayers)){
				BQIDs << BQMyID
				send("BQ.ID"+BQPlayers, BQMyID)
				BQPlayers++
				send("BQ.Enrolled", BQPlayers)
				BQPoints1 = loadFloat("BuzzQuiz.LScore")?: 0.0
				if(BQPoints1>0){
					if(getBoolean(Title+"Your have a score of "+BQPoints1+
						"\n\nDo you want to update?")){
						BQCodes1[BQ1] = makeCode(BQCodes1[BQ1], 5, BQPoints1.toString())
					}
				}
				show(Title+"You can play BuzzQuiz and add a new score before "+
					BQDate0.format("dd-MMM-yyyy HH:mm:ss")+" Either run this "+
					"script directly or via BuzzQuiz")
				showButton("OK")
			}
			else{
				show(Title+"That's not a good forfeit!")
				showButton("OK")
			}
		}
	}else{//enrolled
		BQPoints1 = loadFloat("BuzzQuiz.LScore")?: 0.0
		BQPoints2 = Float.parseFloat(getCode(BQCodes0[BQ1], 5))
		if(BQPoints1!=BQPoints2){
			if(getBoolean(Title+"Your have a new score to add!\n\nPrevious score "+BQPoints2+
				"\n\nCurrent score "+BQPoints1+"\n\nDo you want to update?")){
				BQCodes1[BQ1] = makeCode(BQCodes1[BQ1], 5, BQPoints1.toString())
			}
		}
	}
//display current players
	show(Title+"Forfeits are due between "+BQDate0.format("dd-MMM-yyyy HH:mm:ss")+
		" and "+BQDate1.format("dd-MMM-yyyy HH:mm:ss")+"\n\nRemember to run "+
		"this script (BQCompetition) for the forfeits!")
	showButton("OK")
	if(BQPlayers>0&&getBoolean(Title+"Do you want to see the latest situation and forfeits?")){
		BQShowForfeits()
	}
}
//forfeit ----------------------------------------------------------------------------------------
else if(BQNow.after(BQDate0)&&BQNow.before(BQDate1)){
	if(BQPlayers<2){
		show(Title+"There are to few players for a competition. Try again later!")
		showButton("OK")
		BQStart(BQDate0)
	}else{
		show(Title+"Playing has finished, and the losers have to perform their forfeits (between "+
				BQDate0.format("dd-MMM-yyyy HH:mm:ss")+" and "+
				BQDate1.format("dd-MMM-yyyy HH:mm:ss")+"). They must video their forfeit and post it, "+
				"then enter the URL in this script.")
		showButton("OK")
		def BQ2 = false
		for(def i=0; i<BQPlayers; i++){//have forfeits been assigned?
			if(getCode(BQCodes0[i], 6)=="-1"){BQ2 = true}
		}
		if(BQ2){BQCalcForfeits()}

//your status
		def BQ1 = BQEnrolled()
		if(BQ1>=0){
			BQMyResult = getCode(BQCodes1[BQ1], 6).toInteger()
			def BQMessage = Title
			def BQChoices = ["OK"]
			if(BQMyResult==0){
				BQMessage = BQMessage+"You won! No forfeit for you this time."
			}
			else if(BQMyResult<5){
				BQMessage = BQMessage+"Your forfeit is: "+getCode(BQCodes1[BQ1], BQMyResult)+
						"\n\nURL "+getCode(BQCodes1[BQ1], 7)
				BQChoices << "update URL"
			}
			else{
				BQMessage = BQMessage+"You didn't play so no forfeit."
			}
			if(getSelectedValue(BQMessage, BQChoices)==1){
				getURL(BQ1)
			}
		}

//display latest situation and loser forfeits

		if(getBoolean(Title+"Do you want to see the latest situation and forfeits?")){BQShowForfeits()}
	}
}
//after the tournament-----------------------------------------------------------------------------
else if(BQNow.after(BQDate1)){
	show(Title+"The tournament is over! (ended "+BQDate2.format("dd-MMM-yyyy HH:mm:ss")+")")
	if(receiveInteger("BQ."+receiveInteger("BQ.ID0")+".result")==-1){BQCalcForfeits()}
	showButton("OK")
//display latest situation and loser forfeits
	if(getBoolean(Title+"Do you want to see the latest situation and forfeits?")){BQShowForfeits()}
	if(BQNow.after(BQDate2)){BQStart(BQDate0)}
	else {
		show(Title+"You can start a new competition after "+BQDate2.format("dd-MMM-yyyy HH:mm:ss"))
		showButton("OK")
	}
}
//update any changes
show(Title+"updating...")
for(def i=0; i<BQPlayers; i++) {
	if(BQCodes0[i]==null||BQCodes0[i]!=BQCodes1[i]) {send("BQ."+BQIDs[i], BQCodes1[i])}
}
show(null)
showButton("Bye!")
/*
 * Resources
 * scripts/BQCompetition.groovy
 */
